OPENQASM 2.0;
include "qelib1.inc";

qreg q[8];
creg c[3];
gate bellagioConstraints k,kbar,m,mbar,cstr1,cstr2,all {
  cx k,kbar;
  x kbar;
  cx m,mbar;
  x mbar;
  x kbar;
  x mbar;
  x cstr1;
  ccx kbar,mbar,cstr1;
  x kbar;
  x mbar;
  x k;
  x m;
  x cstr2;
  ccx k,m,cstr2;
  x k;
  x m;
  ccx cstr1,cstr2,all;
}
gate bellagioConstraintsReverse k,kbar,m,mbar,cstr1,cstr2,all {
  ccx cstr1,cstr2,all;
  x k;
  x m;
  ccx k,m,cstr2;
  x k;
  x m;
  x cstr2;
  x kbar;
  x mbar;
  x kbar;
  x mbar;
  x cstr1;
  x mbar;
  cx m,mbar;
  x kbar;
  cx k,kbar;
}
gate mycz a,b {
  h b;
  cx a,b;
  h b;
}
h q[0]; 
h q[2]; 
x q[7]; 
bellagioConstraints q[0],q[1],q[2],q[3],q[4],q[5],q[6]; 
mycz q[6],q[7]; 
bellagioConstraintsReverse q[0],q[1],q[2],q[3],q[4],q[5],q[6]; 

measure q[0] -> c[0];
measure q[2] -> c[1];
measure q[6] -> c[2];