#!/usr/bin/env python
# coding: utf-8

from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer, 
IBMQ)
from qiskit.visualization import plot_histogram



circuit = QuantumCircuit(2,2)
circuit.h(0)
circuit.cx(0,1)
circuit.measure(range(2),range(2))


circuit.draw(output='mpl')

provider.backends()

backend = provider.get_backend('ibmq_16_melbourne')

from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer, 
IBMQ) # (1)
from qiskit.providers.ibmq import least_busy # (2)
from qiskit.visualization import plot_histogram

provider = IBMQ.load_account() # (3)

Set up Quantum Circuit

real_devices = provider.backends(simulator=False, operational=True) # (4)
backend = least_busy(real_devices)

job = execute( circuit, backend, shots=1024 ) # (5)

provider = IBMQ.load_account()
backend = provider.get_backend('Backend')
job = backend.retrieve_job('Job ID')

hist = job.result().get_counts()
plot_histogram( hist )


