#!/usr/bin/env python
# coding: utf-8


import numpy as np
import math
from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram


circuit = QuantumCircuit()
q = QuantumRegister(5,'qreg')
circuit.add_register( q )
c = ClassicalRegister(5,'c')
circuit.add_register( c )


circuit.h( q[0] )


circuit.draw(output='mpl')

circuit.s(q[1])

circuit.draw(output='mpl')

circuit.tdg(q[2])

circuit.draw(output='mpl')

circuit.cnot(q[3],q[4])

circuit.draw(output='mpl')

circuit.u3(0,math.pi,0,q[3])

circuit.draw(output='mpl')

circuit.measure(q[0],c[0])

circuit.draw(output='mpl')


