OPENQASM 2.0;
include "qelib1.inc";

// Initialize Quantum and Classical Registers
qreg q[3];
creg c[2];

// Generate All Combinations
h q[0];
h q[1];

// Tag |01>
x q[0];
ccx q[0],q[1],q[2];
z q[2];
ccx q[0],q[1],q[2];
x q[0];
id q[1]; // Dummy gate to visually line gates

// Canceling Circuit
h q[0];
h q[1];
x q[0];
x q[1];
ccx q[0],q[1],q[2];
z q[2];
ccx q[0],q[1],q[2];
x q[0];
x q[1];
h q[0];
h q[1];

// Collaspe Qubits
measure q[0] -> c[0];
measure q[1] -> c[1];
